=== debian/changelog ===
qpid-proton (0.10-2) unstable; urgency=medium

  * Uploading to unstable.

 -- Thomas Goirand <zigo@debian.org>  Mon, 04 Apr 2016 09:18:57 +0000

qpid-proton (0.10-1) experimental; urgency=medium

  * Added myself as uploader.
  * New upstream release (Closes: #806794):
    - Fixed *-examples.install so that it pickups the folder in
      usr/share/proton-0.10/examples and not usr/share/proton/examples.
  * Switch build-depends from python (>= version) and python-dev (>= version)
    to python-all and python-dev-all.
  * Ran wrap-and-sort -t -a.
  * Added Python3 support (Closes: #806795).

 -- Thomas Goirand <zigo@debian.org>  Tue, 01 Dec 2015 14:00:53 +0000
