=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
#
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.
#
# Modified to make a template file for a multi-binary package with separated
# build-arch and build-indep targets  by Bill Allombert 2001

# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

# DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
# DPKG_EXPORT_BUILDFLAGS = 1
# include /usr/share/dpkg/buildflags.mk

# This has to be exported to make some magic below work.
export DH_OPTIONS
export DH_ALWAYS_EXCLUDE=LICENSE

PYTHONS:=$(shell pyversions -vr)
PYTHON3S:=$(shell py3versions -vr)

%:
	dh $@ --with python2,python3

override_dh_auto_configure:
	dh_auto_configure -- -DPROTON_DISABLE_RPATH=true -DNOBUILD_RUBY=on -DSYSINSTALL_BINDINGS=on

override_dh_auto_build:
	dh_auto_build -- all docs

override_dh_auto_test:
	# TODO enable them when they work again

override_dh_auto_clean:
	dh_auto_clean
	rm -rf	proton-c/bindings/python/build \
		proton-c/bindings/python/cproton.py \
		proton-c/bindings/python/cproton_wrap.c
	find proton-c -iname '*.pyc' -delete
	find proton-c -iname '*.pyo' -delete

# Hack for multiarch
# CMake doesn't really support libdir so we just manually
# move /usr/lib/* to a proper multi-arch location
override_dh_auto_install:
	dh_auto_install
	mkdir -p debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)
	mv debian/tmp/usr/lib/lib*.so* debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)
	set -e ; cd proton-c/bindings/python ; \
		for pyvers in $(PYTHONS); do \
			python$$pyvers setup.py install --install-layout=deb --root $(CURDIR)/debian/tmp ; \
		done ; \
		for pyvers in $(PYTHON3S); do \
			python$$pyvers setup.py install --install-layout=deb --root $(CURDIR)/debian/tmp ; \
		done
